package com.retail_store.order_management.application;

import com.retail_store.order_management.service.RetailStore;
import com.retail_store.order_management.service.RetailStoreService;

import java.sql.SQLException;
import java.util.Scanner;
import java.util.logging.Logger;

import static com.retail_store.order_management.utils.Utility.getInt;


/**
 * The project run starts from here
 */
public class OrderManagement {
    private Scanner scanner;
    private final Logger logger;
    /**
     * Parameterised Constructor for class OrderManagement with their private
     * instance variables
     */
    public OrderManagement() {
        System.setProperty("java.util.logging.SimpleFormatter.format",
                "%5$s %n");
        this.scanner = new Scanner(System.in);
        this.logger = Logger.getLogger(OrderManagement.class.getName());
    }
    /**
     * Method menu where it shows there regular options to go particular
     * functionality regarding the selected option in the console.
     * <p>
     * And also in this method if any exceptions raised those are handled
     */
    public void menu() {
        boolean flag = true;
        logger.info("Welcome to GAP Business Management");
        RetailStore gap = new RetailStoreService();
        String menu = "\n------------------------\nMenu\n------------------------\n" +
                "1. Add product to your stock\n------------------------\n" +
                "2. Order Product\n------------------------\n" +
                "3. Get order details\n------------------------\n" +
                "4. Exit";
        logger.info(menu);
        while (flag) {
            int menuOption;
            menuOption = getInt();
            switch (menuOption) {
                case 1:
                    try {
                        gap.addProducts();
                    } catch (Exception e) {
                        e.printStackTrace();
                        menu();
                    }
                    logger.info("\n------------------------\nPlease enter 5 for menu\n------------------------\n" +
                            "To exit please enter 4\n------------------------\n" +
                            "To Add more enter 1\n------------------------\n");
                    break;
                case 2:
                    gap.placeOrders();
                    logger.info("\n------------------------\nPlease enter 5 for menu\n------------------------\n" +
                            "To exit please enter 4");
                    break;
                case 3:
                    gap.showOrders();
                    logger.info("\n------------------------\nPlease enter 5 for menu\n------------------------\n" +
                            "To exit please enter 4");
                    break;
                case 4:

                    flag = false;
                    break;
                case 5:
                    logger.info(menu);
                    break;
                default:
                    logger.warning("\n------------------------\nPlease enter valid menu option\n------------------------\n");
                    logger.info(menu);
            }
        }
    }
    /**
     * Main method with handling exception if raised
     *
     * @param args
     */
    public static void main(String[] args) throws SQLException {
        OrderManagement orderManagement = new OrderManagement();
        orderManagement.menu();
    }
}
