package com.retail_store.order_management.constants;

/**
 * Enumeration class name Size
 * Here in this the product constant types are taken as per requirement.
 */
public enum Size {
    EXIT(0, "exit"), S(1, "size_s"), M(2, "size_m"), L(3, "size_l"), XL(4, "size_xl"), XXL(5, "size_xxl");
    int option;
    String name;

    public int getOption() {
        return option;
    }
    /**
     * Method used to return the name of the selected option
     * @return String
     */
    public String getName() {
        return name;
    }
    /**
     * Parameterised Constructor
     * @param option
     * @param name
     */
    Size(int option, String name) {
        this.option = option;
        this.name = name;
    }
}
