package com.retail_store.order_management.model;

import lombok.AccessLevel;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.time.LocalDate;
import java.time.LocalTime;
import java.util.List;

/**
 * This is order class with some states and behaviour
 *  With all instance variables as private
 */
@Getter
@AllArgsConstructor
public class Order {
    private String orderId;
    private LocalDate orderDate;
    private LocalTime localTime;
    private String customerName;
    private String phoneNumber;
    private double totalBill;
    List<OrderedProduct> productsList;
    /**
     * This method is used to get the order details in brief
     * @return string
     */
    public String showOrder() {
        return "order id : " + orderId + "\nCustomer name: " + customerName + "\tPhone number: " + phoneNumber + "\nDate: " + orderDate + "\tTime: " + localTime + "\n Total Bill: " + totalBill;
    }
    /**
     * This method is used to get the all products list present.
     * @return string
     */
    public String showProducts() {
        return productsList.stream().map(product -> product.getId() + "\t" + product.getName() + "\n" + product.getCategory() + "\t" + product.getSize() + "\n" + product.getQuantity() + "\t" + product.getPrice() + "\t" + product.getQuantity() * product.getPrice()).reduce("", (productsList, product) -> productsList + "\n" + product);
    }

}
