package com.retail_store.order_management.service;


import com.retail_store.order_management.model.OrderedProduct;
import com.retail_store.order_management.model.Product;

import java.sql.Connection;
import java.util.Collection;

/**
 * Interface RetailStore
 * In this interface there present different abstract methods to perform
 * various functions of the project
 */
public interface RetailStore {
    /**
     * This abstract method is used to add the products seemly according to the
     * given process in the console, if added then shows message accordingly
     * @return boolean -> true/false
     */
    public boolean addProducts();

    /**
     * This abstract method is used to place the orders of the available products
     * @return boolean -> true/false
     */
    public boolean placeOrders();

    /**
     * This abstract method is used to show what all orders are generated
     */
    public void showOrders();

    /**
     * This abstract method is used to generate order list of the products those placed
     * @param connection
     * @return OrderedProduct
     */
    public Collection<OrderedProduct> createOrder(Connection connection);

    /**
     * This abstract method is used to push all the chosen products to the cart
     * @param cart
     * @param product
     * @param connection
     * @return boolean -> true/false
     */
    public boolean addProductToCart(Collection<OrderedProduct> cart, Product product, Connection connection);
}
